From patchwork Mon Nov 14 12:50:50 2022
Content-Type: text/plain; charset="utf-8"
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-Patchwork-Submitter: Jason Yan <yanaijie@huawei.com>
X-Patchwork-Id: 183238
Return-Path: <yanaijie@huawei.com>
Received: from dggems705-chm.china.huawei.com (10.3.19.182) by
 dggems702-chm.china.huawei.com (10.3.19.179) with Microsoft SMTP Server
 (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id
 15.1.2375.31 via Mailbox Transport; Mon, 14 Nov 2022 20:33:19 +0800
Received: from canpemm500004.china.huawei.com (7.192.104.92) by
 dggems705-chm.china.huawei.com (10.3.19.182) with Microsoft SMTP Server
 (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id
 15.1.2375.31; Mon, 14 Nov 2022 20:33:19 +0800
Received: from huawei.com (10.175.127.227) by canpemm500004.china.huawei.com
 (7.192.104.92) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id 15.1.2375.31; Mon, 14 Nov
 2022 20:33:18 +0800
From: Jason Yan <yanaijie@huawei.com>
To: <yanaijie@huawei.com>, <zhengzengkai@huawei.com>, <xiexiuqi@huawei.com>,
	<yi.zhang@huawei.com>, <patchwork@huawei.com>, <kernel.openeuler@huawei.com>,
	<houtao1@huawei.com>
Subject: [PATCH OLK-5.10 v2 141/308] ksmbd: replace KSMBD_ALIGN with kernel
 ALIGN macro
Date: Mon, 14 Nov 2022 20:50:50 +0800
Message-ID: <20221114125337.1831594-142-yanaijie@huawei.com>
X-Mailer: git-send-email 2.31.1
In-Reply-To: <20221114125337.1831594-1-yanaijie@huawei.com>
References: <20221114125337.1831594-1-yanaijie@huawei.com>
Content-Type: text/plain
X-MS-Exchange-Organization-Network-Message-Id: 
 9a2e3233-4656-439f-2215-08dac63c68f7
X-MS-Exchange-Organization-AuthSource: canpemm500004.china.huawei.com
X-MS-Exchange-Organization-AuthAs: Internal
X-MS-Exchange-Organization-AuthMechanism: 07
X-Originating-IP: [10.175.127.227]
X-ClientProxiedBy: dggems702-chm.china.huawei.com (10.3.19.179) To
 canpemm500004.china.huawei.com (7.192.104.92)
X-MS-Exchange-Transport-EndToEndLatency: 00:00:00.7062487
X-MS-Exchange-Processed-By-BccFoldering: 15.01.2375.031
MIME-Version: 1.0

From: Hyunchul Lee <hyc.lee@gmail.com>

mainline inclusion
from mainline-5.15-rc1
commit c2220322b4577fc32ad3b7b4ddb856bd1f8c7461
category: feature
bugzilla: https://gitee.com/openeuler/kernel/issues/I60T7G
CVE: NA

Reference: https://git.kernel.org/torvalds/linux/c/c2220322b457

-------------------------------

Replace KSMBD_ALIGN with kernel ALIGN macro

Reviewed-by: Christoph Hellwig <hch@lst.de>
Signed-off-by: Hyunchul Lee <hyc.lee@gmail.com>
Signed-off-by: Namjae Jeon <namjae.jeon@samsung.com>
Signed-off-by: Steve French <stfrench@microsoft.com>
Signed-off-by: Jason Yan <yanaijie@huawei.com>
---
 fs/ksmbd/ndr.c | 27 ++++++---------------------
 1 file changed, 6 insertions(+), 21 deletions(-)

diff --git a/fs/ksmbd/ndr.c b/fs/ksmbd/ndr.c
index 46cc01475d38..db2ec07e076e 100644
--- a/fs/ksmbd/ndr.c
+++ b/fs/ksmbd/ndr.c
@@ -11,21 +11,6 @@
 
 #define PAYLOAD_HEAD(d) ((d)->data + (d)->offset)
 
-#define KSMBD_ALIGN_MASK(x, mask) (((x) + (mask)) & ~(mask))
-
-#define KSMBD_ALIGN(x, a)							\
-	({									\
-		typeof(x) ret = (x);						\
-		if (((x) & ((typeof(x))(a) - 1)) != 0)				\
-			ret = KSMBD_ALIGN_MASK(x, (typeof(x))(a) - 1);		\
-		ret;								\
-	})
-
-static void align_offset(struct ndr *ndr, int n)
-{
-	ndr->offset = KSMBD_ALIGN(ndr->offset, n);
-}
-
 static int try_to_realloc_ndr_blob(struct ndr *n, size_t sz)
 {
 	char *data;
@@ -85,7 +70,7 @@ static int ndr_write_string(struct ndr *n, void *value, size_t sz)
 	strncpy(PAYLOAD_HEAD(n), value, sz);
 	sz++;
 	n->offset += sz;
-	align_offset(n, 2);
+	n->offset = ALIGN(n->offset, 2);
 	return 0;
 }
 
@@ -96,7 +81,7 @@ static int ndr_read_string(struct ndr *n, void *value, size_t sz)
 	memcpy(value, PAYLOAD_HEAD(n), len);
 	len++;
 	n->offset += len;
-	align_offset(n, 2);
+	n->offset = ALIGN(n->offset, 2);
 	return 0;
 }
 
@@ -210,20 +195,20 @@ static int ndr_encode_posix_acl_entry(struct ndr *n, struct xattr_smb_acl *acl)
 	int i;
 
 	ndr_write_int32(n, acl->count);
-	align_offset(n, 8);
+	n->offset = ALIGN(n->offset, 8);
 	ndr_write_int32(n, acl->count);
 	ndr_write_int32(n, 0);
 
 	for (i = 0; i < acl->count; i++) {
-		align_offset(n, 8);
+		n->offset = ALIGN(n->offset, 8);
 		ndr_write_int16(n, acl->entries[i].type);
 		ndr_write_int16(n, acl->entries[i].type);
 
 		if (acl->entries[i].type == SMB_ACL_USER) {
-			align_offset(n, 8);
+			n->offset = ALIGN(n->offset, 8);
 			ndr_write_int64(n, acl->entries[i].uid);
 		} else if (acl->entries[i].type == SMB_ACL_GROUP) {
-			align_offset(n, 8);
+			n->offset = ALIGN(n->offset, 8);
 			ndr_write_int64(n, acl->entries[i].gid);
 		}
 

